install 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. OS=$(uname -s)
  13. if [ $OS = "Linux" ]; then
  14. OS="GNU/Linux"
  15. if [ -f /etc/os-release ]; then
  16. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  17. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  18. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. for i in $ID_LIKE; do
  20. #printf "$i\n"
  21. case $i in
  22. debian|ubuntu)
  23. debianOS=true
  24. break
  25. ;;
  26. rhel|fedora)
  27. rhelOS=true
  28. break
  29. ;;
  30. *)
  31. debianOS=false
  32. rhelOS=false
  33. ;;
  34. esac
  35. done
  36. elif [ -f /etc/debian-version ]; then
  37. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  38. DIST="Debian"
  39. REV=""
  40. ID_LIKE="debian"
  41. debianOS=true
  42. elif [ -f /etc/redhat-release ]; then
  43. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  44. DIST="Red-Hat"
  45. REV=""
  46. ID_LIKE="rhel"
  47. rhelOS=true
  48. else
  49. # Other Linux (No Soportado)
  50. DIST=""
  51. REV=""
  52. ID_LIKE=""
  53. fi
  54. else
  55. # UNIX, OS X, ... (No Soportado)
  56. DIST=$OS
  57. REV=""
  58. fi
  59. #printf " $OS $DIST $REV\n"
  60. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  61. }
  62. comprobarRoot() {
  63. if [ $(id -u) -ne 0 ]; then
  64. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  65. exit 1
  66. fi
  67. }
  68. comprobarDependencias() {
  69. # Comprobamos whiptail
  70. which whiptail > /dev/null 2>&1
  71. if [ $? -ne 0 ];then
  72. printf "ERROR:\t'whiptail' no disponible.\n"
  73. exit 1
  74. fi
  75. # Comprobamos hostnamectl
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. # Comprobamos apt-get
  83. which apt-get > /dev/null 2>&1
  84. if [ $? -ne 0 ]; then
  85. printf "ERROR:\t'apt-get' no está disponible.\n"
  86. exit 1
  87. fi
  88. # Actualizamos base de datos del repositorio
  89. printf "Actualizando repositorio APT..."
  90. result=$(apt-get -q -y update)
  91. if [ $? -ne 0 ]; then
  92. printf "\nERROR:\tImposible actualizar repositorio.\n"
  93. printf "Detalles:\n$result\n"
  94. exit 1
  95. fi
  96. printf " OK.\n"
  97. # Comprobamos Firewall (ufw)
  98. which ufw > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'ufw' no disponible.\n"
  101. exit 1
  102. fi
  103. fi
  104. if [ $rhelOS = true ]; then
  105. # Comprobamos yum
  106. which yum > /dev/null 2>&1
  107. if [ $? -ne 0 ]; then
  108. printf "ERROR:\t'yum' no está disponible.\n"
  109. exit 1
  110. fi
  111. # Actualizamos base de datos del repositorio
  112. printf "Actualizando repositorio YUM..."
  113. result=$(yum -y makecache 2>&1)
  114. if [ $? -ne 0 ]; then
  115. printf "\nERROR:\tImposible actualizar repositorio.\n"
  116. printf "Detalles:\n$result\n"
  117. exit 1
  118. fi
  119. printf " OK.\n"
  120. # Comprobamos Firewall (firewall-cmd)
  121. which firewall-cmd > /dev/null 2>&1
  122. if [ $? -ne 0 ]; then
  123. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  124. exit 1
  125. fi
  126. fi
  127. }
  128. inicializarVariables() {
  129. debianOS=false
  130. rhelOS=false
  131. apacheOn=false
  132. nginxOn=false
  133. mySQLOn=false
  134. mariaDBOn=false
  135. phpOn=false
  136. mediaWikiOn=false
  137. moodleOn=false
  138. actualizacionesOn=false
  139. }
  140. instalacionExpress() {
  141. apacheOn=true
  142. mariaDBOn=true
  143. phpOn=true
  144. mediaWikiOn=true
  145. moodleOn=true
  146. actualizacionesOn=true
  147. }
  148. comprobarHostname() {
  149. while [ -z $hostname ]; do
  150. hostname=$(whiptail --title "HOSTNAME" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  151. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  152. hostnamectl set-hostname $hostname
  153. else
  154. hostname=$(hostname)
  155. fi
  156. done
  157. #printf "\nHostname: $hostname\n"
  158. }
  159. mostrarBienvenida() {
  160. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  161. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  162. exit 1
  163. fi
  164. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  165. if [ $? -ne 0 ]; then
  166. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  167. exit 2
  168. fi
  169. }
  170. mostrarExpress() {
  171. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  172. "Express" "Instalación rápida" ON \
  173. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  174. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  175. if [ $? -ne 0 ]; then
  176. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  177. exit 2
  178. fi
  179. case $express in
  180. Express)
  181. instalacionExpress
  182. ;;
  183. Avanzada)
  184. mostrarComponentes
  185. ;;
  186. *)
  187. printf "ERROR:\tError interno (selección express).\n"
  188. exit 1
  189. ;;
  190. esac
  191. }
  192. mostrarComponentes() {
  193. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  194. "WebServer" "Instalar servidor web http/https" ON \
  195. "Database" "Instalar una base de datos SQL" ON \
  196. "PHP" "Instala PHP7" ON \
  197. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  198. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  199. "Moodle" "Instalar campus virtual con Moodle" ON \
  200. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  201. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  202. if [ $? -ne 0 ]; then
  203. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  204. exit 2
  205. fi
  206. # Mejora: autodetección de componentes ya instalados
  207. for i in $componentes; do
  208. case $i in
  209. \"WebServer\")
  210. mostrarWebServer
  211. ;;
  212. \"Database\")
  213. mostrarDatabase
  214. ;;
  215. \"PHP\")
  216. phpOn=true
  217. ;;
  218. \"SSL/TLS\")
  219. # 2 Opciones: Let's Encrypt o Autofirmado
  220. ;;
  221. \"MediaWiki\")
  222. mediaWikiOn=true
  223. ;;
  224. \"Moodle\")
  225. moodleOn=true
  226. ;;
  227. \"Actualizaciones\")
  228. actualizacionesOn=true
  229. ;;
  230. *)
  231. printf "ERROR:\tError interno (selección de componentes).\n"
  232. exit 1
  233. ;;
  234. esac
  235. done
  236. }
  237. mostrarWebServer() {
  238. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  239. "Apache" "Instalar el servidor web Apache2" ON \
  240. "Nginx" "Instalar el servidor web Nginx" OFF \
  241. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  242. if [ $? -ne 0 ]; then
  243. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  244. exit 2
  245. fi
  246. # Preguntar otras opciones de configuración
  247. comprobarHostname
  248. case $webServer in
  249. Apache)
  250. apacheOn=true
  251. ;;
  252. Nginx)
  253. nginxOn=true
  254. ;;
  255. *)
  256. printf "ERROR:\tError interno (selección de web server).\n"
  257. exit 1
  258. ;;
  259. esac
  260. }
  261. instalarApache() {
  262. if [ $debianOS = true ];then
  263. result=$(apt-get -q -y install apache2 2>&1)
  264. if [ $? -ne 0 ]; then
  265. printf "\nERROR:\tError al instalar Apache2.\n"
  266. printf "Detalles:\n$result\n"
  267. exit 1
  268. fi
  269. elif [ $rhelOS = true ]; then
  270. result=$(yum -y install httpd 2>&1)
  271. if [ $? -ne 0 ]; then
  272. printf "\nERROR:\tError al instalar Apache2.\n"
  273. printf "Detalles:\n$result\n"
  274. exit 1
  275. fi
  276. else
  277. printf "\nERROR:\tError interno (instalación Apache2).\n"
  278. exit 1
  279. fi
  280. }
  281. instalarNginx() {
  282. if [ $debianOS = true ];then
  283. result=$(apt-get -q -y install nginx 2>&1)
  284. if [ $? -ne 0 ]; then
  285. printf "\nERROR:\tError al instalar Nginx.\n"
  286. printf "Detalles:\n$result\n"
  287. exit 1
  288. fi
  289. elif [ $rhelOS = true ]; then
  290. # Hay que instalar primero otro repositorio
  291. result=$(yum -y install epel-release)
  292. if [ $? -ne 0 ]; then
  293. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  294. printf "Detalles:\n$result\n"
  295. exit 1
  296. fi
  297. result=$(yum -y install nginx 2>&1)
  298. if [ $? -ne 0 ]; then
  299. printf "\nERROR:\tError al instalar Nginx.\n"
  300. printf "Detalles:\n$result\n"
  301. exit 1
  302. fi
  303. else
  304. printf "\nERROR:\tError interno (instalación Nginx).\n"
  305. exit 1
  306. fi
  307. }
  308. mostrarDatabase() {
  309. if [ $debianOS = true ]; then
  310. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  311. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  312. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  313. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  314. if [ $? -ne 0 ]; then
  315. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  316. exit 2
  317. fi
  318. # Preguntar otras opciones de configuración
  319. case $database in
  320. MySQL)
  321. mySQLOn=true
  322. ;;
  323. MariaDB)
  324. mariaDBOn=true
  325. ;;
  326. *)
  327. printf "ERROR:\tError interno (selección de base de datos).\n"
  328. exit 1
  329. ;;
  330. esac
  331. elif [ $rhelOS = true ]; then
  332. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  333. if [ $? -ne 0 ]; then
  334. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  335. exit 2
  336. fi
  337. mariaDBOn=true
  338. else
  339. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  340. exit 1
  341. fi
  342. }
  343. instalarMySQL() {
  344. if [ $debianOS = true ];then
  345. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  346. if [ $? -ne 0 ]; then
  347. printf "\nERROR:\tError al instalar MySQL.\n"
  348. printf "Detalles:\n$result\n"
  349. exit 1
  350. fi
  351. elif [ $rhelOS = true ]; then
  352. # MySQL no disponible en RHEL. 2 opciones:
  353. # 1) Instalar un repositorio adicional
  354. # 2) No instalar MySQL en distribuciones RHEL
  355. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  356. exit 1
  357. else
  358. printf "\nERROR:\tError interno (instalación MySQL).\n"
  359. exit 1
  360. fi
  361. }
  362. instalarMariaDB() {
  363. if [ $debianOS = true ];then
  364. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  365. if [ $? -ne 0 ]; then
  366. printf "\nERROR:\tError al instalar MariaDB.\n"
  367. printf "Detalles:\n$result\n"
  368. exit 1
  369. fi
  370. elif [ $rhelOS = true ]; then
  371. result=$(yum -y install mariadb-server 2>&1)
  372. if [ $? -ne 0 ]; then
  373. printf "\nERROR:\tError al instalar MariaDB.\n"
  374. printf "Detalles:\n$result\n"
  375. exit 1
  376. fi
  377. else
  378. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  379. exit 1
  380. fi
  381. }
  382. # Comprobación del sistema e inicialización
  383. comprobarRoot
  384. inicializarVariables
  385. OSInfo
  386. comprobarDependencias
  387. # Bienvenida
  388. mostrarBienvenida
  389. # Selección de componentes (express vs avanzada)
  390. mostrarExpress
  391. # Pre-configuración
  392. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  393. # Instalación
  394. # FALTA: whiptail --gauge -> Más bonito
  395. # Servidor Web
  396. if [ $apacheOn = true ]; then
  397. printf "Instalando Web Server Apache..."
  398. instalarApache
  399. printf " OK.\n"
  400. elif [ $nginxOn = true ]; then
  401. printf "Instalando Web Server Nginx..."
  402. instalarNginx
  403. printf " OK.\n"
  404. else
  405. printf "ERROR:\tError interno (instalación Web Server).\n"
  406. exit 1
  407. fi
  408. # Base de Datos
  409. if [ $mySQLOn = true ]; then
  410. printf "Instalando Base de Datos MySQL..."
  411. instalarMySQL
  412. printf " OK.\n"
  413. elif [ $mariaDBOn = true ]; then
  414. printf "Instalando Base de Datos MariaDB..."
  415. instalarMariaDB
  416. printf " OK.\n"
  417. else
  418. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  419. exit 1
  420. fi
  421. # PHP
  422. if [ $phpOn = true ]; then
  423. printf "Instalando PHP-7..."
  424. printf " OK.\n"
  425. fi
  426. # SSL/TLS
  427. # Falta por implementar
  428. # MediaWiki
  429. if [ $mediaWikiOn = true ]; then
  430. printf "Instalando MediaWiki..."
  431. printf " OK.\n"
  432. fi
  433. # Moodle
  434. if [ $moodleOn = true ]; then
  435. printf "Instalando Moodle..."
  436. printf " OK.\n"
  437. fi
  438. # Configuración
  439. # Configuración Apache
  440. # Virtual Hosts
  441. # Configuración Database
  442. # Configuración Segura
  443. # Configuración PHP
  444. # cgi.fix_pathinfo=0
  445. # Configurar máximo de subida de archivos
  446. # Configuración MediWiki
  447. # Configuración Moodle
  448. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  449. # Añadir reglas del cortafuegos
  450. # Configuración SSL/TLS
  451. # Generar certificados
  452. # Configurar certificados
  453. # Configurar actualizaciones
  454. if [ $actualizacionesOn = true ]; then
  455. printf "Configurando actualizaciones automáticas..."
  456. printf " OK.\n"
  457. fi
  458. # Autodestrucción
  459. {
  460. for i in $(seq 0 5 50); do
  461. sleep 0.1
  462. echo $i
  463. done
  464. } | whiptail --gauge "Autodestrucción..." 7 70 0
  465. {
  466. for i in $(seq 50 5 100); do
  467. sleep 0.1
  468. echo $i
  469. done
  470. } | whiptail --gauge "Autopulverización..." 7 70 50